<?php
/**
 * Point
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * Point Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class Point implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Point';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'external_id' => 'string',
        'name' => 'string',
        'description' => 'string',
        'phone' => 'string',
        'address_reduce' => 'string',
        'metro_station' => 'string',
        'only_online_payment' => 'bool',
        'has_payment_card' => 'bool',
        'has_courier' => 'bool',
        'is_postamat' => 'bool',
        'max_value' => 'string',
        'max_weight' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'delivery_service_id' => 'int',
        'is_active' => 'bool',
        'address' => '\Ensi\LogisticClient\Dto\Address',
        'city_guid' => 'string',
        'geo_lat' => 'string',
        'geo_lon' => 'string',
        'timezone' => 'string',
        'point_workings' => '\Ensi\LogisticClient\Dto\PointWorking[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'external_id' => null,
        'name' => null,
        'description' => null,
        'phone' => null,
        'address_reduce' => null,
        'metro_station' => null,
        'only_online_payment' => null,
        'has_payment_card' => null,
        'has_courier' => null,
        'is_postamat' => null,
        'max_value' => null,
        'max_weight' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'delivery_service_id' => null,
        'is_active' => null,
        'address' => null,
        'city_guid' => null,
        'geo_lat' => null,
        'geo_lon' => null,
        'timezone' => null,
        'point_workings' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'external_id' => false,
        'name' => false,
        'description' => true,
        'phone' => true,
        'address_reduce' => true,
        'metro_station' => true,
        'only_online_payment' => true,
        'has_payment_card' => true,
        'has_courier' => true,
        'is_postamat' => true,
        'max_value' => true,
        'max_weight' => true,
        'created_at' => false,
        'updated_at' => false,
        'delivery_service_id' => true,
        'is_active' => false,
        'address' => true,
        'city_guid' => true,
        'geo_lat' => true,
        'geo_lon' => true,
        'timezone' => true,
        'point_workings' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'external_id' => 'external_id',
        'name' => 'name',
        'description' => 'description',
        'phone' => 'phone',
        'address_reduce' => 'address_reduce',
        'metro_station' => 'metro_station',
        'only_online_payment' => 'only_online_payment',
        'has_payment_card' => 'has_payment_card',
        'has_courier' => 'has_courier',
        'is_postamat' => 'is_postamat',
        'max_value' => 'max_value',
        'max_weight' => 'max_weight',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'delivery_service_id' => 'delivery_service_id',
        'is_active' => 'is_active',
        'address' => 'address',
        'city_guid' => 'city_guid',
        'geo_lat' => 'geo_lat',
        'geo_lon' => 'geo_lon',
        'timezone' => 'timezone',
        'point_workings' => 'point_workings'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'external_id' => 'setExternalId',
        'name' => 'setName',
        'description' => 'setDescription',
        'phone' => 'setPhone',
        'address_reduce' => 'setAddressReduce',
        'metro_station' => 'setMetroStation',
        'only_online_payment' => 'setOnlyOnlinePayment',
        'has_payment_card' => 'setHasPaymentCard',
        'has_courier' => 'setHasCourier',
        'is_postamat' => 'setIsPostamat',
        'max_value' => 'setMaxValue',
        'max_weight' => 'setMaxWeight',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'delivery_service_id' => 'setDeliveryServiceId',
        'is_active' => 'setIsActive',
        'address' => 'setAddress',
        'city_guid' => 'setCityGuid',
        'geo_lat' => 'setGeoLat',
        'geo_lon' => 'setGeoLon',
        'timezone' => 'setTimezone',
        'point_workings' => 'setPointWorkings'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'external_id' => 'getExternalId',
        'name' => 'getName',
        'description' => 'getDescription',
        'phone' => 'getPhone',
        'address_reduce' => 'getAddressReduce',
        'metro_station' => 'getMetroStation',
        'only_online_payment' => 'getOnlyOnlinePayment',
        'has_payment_card' => 'getHasPaymentCard',
        'has_courier' => 'getHasCourier',
        'is_postamat' => 'getIsPostamat',
        'max_value' => 'getMaxValue',
        'max_weight' => 'getMaxWeight',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'delivery_service_id' => 'getDeliveryServiceId',
        'is_active' => 'getIsActive',
        'address' => 'getAddress',
        'city_guid' => 'getCityGuid',
        'geo_lat' => 'getGeoLat',
        'geo_lon' => 'getGeoLon',
        'timezone' => 'getTimezone',
        'point_workings' => 'getPointWorkings'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('description', $data, null);
        $this->setIfExists('phone', $data, null);
        $this->setIfExists('address_reduce', $data, null);
        $this->setIfExists('metro_station', $data, null);
        $this->setIfExists('only_online_payment', $data, null);
        $this->setIfExists('has_payment_card', $data, null);
        $this->setIfExists('has_courier', $data, null);
        $this->setIfExists('is_postamat', $data, null);
        $this->setIfExists('max_value', $data, null);
        $this->setIfExists('max_weight', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('delivery_service_id', $data, null);
        $this->setIfExists('is_active', $data, null);
        $this->setIfExists('address', $data, null);
        $this->setIfExists('city_guid', $data, null);
        $this->setIfExists('geo_lat', $data, null);
        $this->setIfExists('geo_lon', $data, null);
        $this->setIfExists('timezone', $data, null);
        $this->setIfExists('point_workings', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['external_id'] === null) {
            $invalidProperties[] = "'external_id' can't be null";
        }
        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        if ($this->container['description'] === null) {
            $invalidProperties[] = "'description' can't be null";
        }
        if ($this->container['phone'] === null) {
            $invalidProperties[] = "'phone' can't be null";
        }
        if ($this->container['address_reduce'] === null) {
            $invalidProperties[] = "'address_reduce' can't be null";
        }
        if ($this->container['metro_station'] === null) {
            $invalidProperties[] = "'metro_station' can't be null";
        }
        if ($this->container['only_online_payment'] === null) {
            $invalidProperties[] = "'only_online_payment' can't be null";
        }
        if ($this->container['has_payment_card'] === null) {
            $invalidProperties[] = "'has_payment_card' can't be null";
        }
        if ($this->container['has_courier'] === null) {
            $invalidProperties[] = "'has_courier' can't be null";
        }
        if ($this->container['is_postamat'] === null) {
            $invalidProperties[] = "'is_postamat' can't be null";
        }
        if ($this->container['max_value'] === null) {
            $invalidProperties[] = "'max_value' can't be null";
        }
        if ($this->container['max_weight'] === null) {
            $invalidProperties[] = "'max_weight' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Идентификатор пункта
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string $external_id Id пункта у службы доставки
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {


        /*if (is_null($external_id)) {
            throw new \InvalidArgumentException('non-nullable external_id cannot be null');
        }*/
        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name Название пункта
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description Описание проезда
     *
     * @return $this
     */
    public function setDescription($description)
    {

        if (is_null($description)) {
            array_push($this->openAPINullablesSetToNull, 'description');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('description', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets phone
     *
     * @return string|null
     */
    public function getPhone()
    {
        return $this->container['phone'];
    }

    /**
     * Sets phone
     *
     * @param string|null $phone Телефон
     *
     * @return $this
     */
    public function setPhone($phone)
    {

        if (is_null($phone)) {
            array_push($this->openAPINullablesSetToNull, 'phone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('phone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['phone'] = $phone;

        return $this;
    }

    /**
     * Gets address_reduce
     *
     * @return string|null
     */
    public function getAddressReduce()
    {
        return $this->container['address_reduce'];
    }

    /**
     * Sets address_reduce
     *
     * @param string|null $address_reduce Cокращенный адрес пвз
     *
     * @return $this
     */
    public function setAddressReduce($address_reduce)
    {

        if (is_null($address_reduce)) {
            array_push($this->openAPINullablesSetToNull, 'address_reduce');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('address_reduce', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['address_reduce'] = $address_reduce;

        return $this;
    }

    /**
     * Gets metro_station
     *
     * @return string|null
     */
    public function getMetroStation()
    {
        return $this->container['metro_station'];
    }

    /**
     * Sets metro_station
     *
     * @param string|null $metro_station Cтанция метро
     *
     * @return $this
     */
    public function setMetroStation($metro_station)
    {

        if (is_null($metro_station)) {
            array_push($this->openAPINullablesSetToNull, 'metro_station');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('metro_station', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['metro_station'] = $metro_station;

        return $this;
    }

    /**
     * Gets only_online_payment
     *
     * @return bool|null
     */
    public function getOnlyOnlinePayment()
    {
        return $this->container['only_online_payment'];
    }

    /**
     * Sets only_online_payment
     *
     * @param bool|null $only_online_payment Выдача только полностью оплаченных посылок
     *
     * @return $this
     */
    public function setOnlyOnlinePayment($only_online_payment)
    {

        if (is_null($only_online_payment)) {
            array_push($this->openAPINullablesSetToNull, 'only_online_payment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('only_online_payment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['only_online_payment'] = $only_online_payment;

        return $this;
    }

    /**
     * Gets has_payment_card
     *
     * @return bool|null
     */
    public function getHasPaymentCard()
    {
        return $this->container['has_payment_card'];
    }

    /**
     * Sets has_payment_card
     *
     * @param bool|null $has_payment_card Возможна ли оплата картой
     *
     * @return $this
     */
    public function setHasPaymentCard($has_payment_card)
    {

        if (is_null($has_payment_card)) {
            array_push($this->openAPINullablesSetToNull, 'has_payment_card');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('has_payment_card', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['has_payment_card'] = $has_payment_card;

        return $this;
    }

    /**
     * Gets has_courier
     *
     * @return bool|null
     */
    public function getHasCourier()
    {
        return $this->container['has_courier'];
    }

    /**
     * Sets has_courier
     *
     * @param bool|null $has_courier Осуществляется ли курьерская доставка
     *
     * @return $this
     */
    public function setHasCourier($has_courier)
    {

        if (is_null($has_courier)) {
            array_push($this->openAPINullablesSetToNull, 'has_courier');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('has_courier', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['has_courier'] = $has_courier;

        return $this;
    }

    /**
     * Gets is_postamat
     *
     * @return bool|null
     */
    public function getIsPostamat()
    {
        return $this->container['is_postamat'];
    }

    /**
     * Sets is_postamat
     *
     * @param bool|null $is_postamat Отделение является постаматом
     *
     * @return $this
     */
    public function setIsPostamat($is_postamat)
    {

        if (is_null($is_postamat)) {
            array_push($this->openAPINullablesSetToNull, 'is_postamat');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_postamat', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_postamat'] = $is_postamat;

        return $this;
    }

    /**
     * Gets max_value
     *
     * @return string|null
     */
    public function getMaxValue()
    {
        return $this->container['max_value'];
    }

    /**
     * Sets max_value
     *
     * @param string|null $max_value Ограничение объема (куб.метры)
     *
     * @return $this
     */
    public function setMaxValue($max_value)
    {

        if (is_null($max_value)) {
            array_push($this->openAPINullablesSetToNull, 'max_value');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('max_value', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['max_value'] = $max_value;

        return $this;
    }

    /**
     * Gets max_weight
     *
     * @return int|null
     */
    public function getMaxWeight()
    {
        return $this->container['max_weight'];
    }

    /**
     * Sets max_weight
     *
     * @param int|null $max_weight Ограничение веса (кг)
     *
     * @return $this
     */
    public function setMaxWeight($max_weight)
    {

        if (is_null($max_weight)) {
            array_push($this->openAPINullablesSetToNull, 'max_weight');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('max_weight', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['max_weight'] = $max_weight;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Дата создания
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Дата обновления
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets delivery_service_id
     *
     * @return int|null
     */
    public function getDeliveryServiceId()
    {
        return $this->container['delivery_service_id'];
    }

    /**
     * Sets delivery_service_id
     *
     * @param int|null $delivery_service_id Идентификатор службы доставки из DeliveryServiceEnum
     *
     * @return $this
     */
    public function setDeliveryServiceId($delivery_service_id)
    {

        if (is_null($delivery_service_id)) {
            array_push($this->openAPINullablesSetToNull, 'delivery_service_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('delivery_service_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['delivery_service_id'] = $delivery_service_id;

        return $this;
    }

    /**
     * Gets is_active
     *
     * @return bool|null
     */
    public function getIsActive()
    {
        return $this->container['is_active'];
    }

    /**
     * Sets is_active
     *
     * @param bool|null $is_active Активность
     *
     * @return $this
     */
    public function setIsActive($is_active)
    {


        /*if (is_null($is_active)) {
            throw new \InvalidArgumentException('non-nullable is_active cannot be null');
        }*/
        $this->container['is_active'] = $is_active;

        return $this;
    }

    /**
     * Gets address
     *
     * @return \Ensi\LogisticClient\Dto\Address|null
     */
    public function getAddress()
    {
        return $this->container['address'];
    }

    /**
     * Sets address
     *
     * @param \Ensi\LogisticClient\Dto\Address|null $address address
     *
     * @return $this
     */
    public function setAddress($address)
    {

        if (is_null($address)) {
            array_push($this->openAPINullablesSetToNull, 'address');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('address', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['address'] = $address;

        return $this;
    }

    /**
     * Gets city_guid
     *
     * @return string|null
     */
    public function getCityGuid()
    {
        return $this->container['city_guid'];
    }

    /**
     * Sets city_guid
     *
     * @param string|null $city_guid ФИАС id населенного пункта
     *
     * @return $this
     */
    public function setCityGuid($city_guid)
    {

        if (is_null($city_guid)) {
            array_push($this->openAPINullablesSetToNull, 'city_guid');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('city_guid', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['city_guid'] = $city_guid;

        return $this;
    }

    /**
     * Gets geo_lat
     *
     * @return string|null
     */
    public function getGeoLat()
    {
        return $this->container['geo_lat'];
    }

    /**
     * Sets geo_lat
     *
     * @param string|null $geo_lat Широта
     *
     * @return $this
     */
    public function setGeoLat($geo_lat)
    {

        if (is_null($geo_lat)) {
            array_push($this->openAPINullablesSetToNull, 'geo_lat');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('geo_lat', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['geo_lat'] = $geo_lat;

        return $this;
    }

    /**
     * Gets geo_lon
     *
     * @return string|null
     */
    public function getGeoLon()
    {
        return $this->container['geo_lon'];
    }

    /**
     * Sets geo_lon
     *
     * @param string|null $geo_lon Долгота
     *
     * @return $this
     */
    public function setGeoLon($geo_lon)
    {

        if (is_null($geo_lon)) {
            array_push($this->openAPINullablesSetToNull, 'geo_lon');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('geo_lon', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['geo_lon'] = $geo_lon;

        return $this;
    }

    /**
     * Gets timezone
     *
     * @return string|null
     */
    public function getTimezone()
    {
        return $this->container['timezone'];
    }

    /**
     * Sets timezone
     *
     * @param string|null $timezone Часовой пояс
     *
     * @return $this
     */
    public function setTimezone($timezone)
    {

        if (is_null($timezone)) {
            array_push($this->openAPINullablesSetToNull, 'timezone');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('timezone', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['timezone'] = $timezone;

        return $this;
    }

    /**
     * Gets point_workings
     *
     * @return \Ensi\LogisticClient\Dto\PointWorking[]|null
     */
    public function getPointWorkings()
    {
        return $this->container['point_workings'];
    }

    /**
     * Sets point_workings
     *
     * @param \Ensi\LogisticClient\Dto\PointWorking[]|null $point_workings Время работы
     *
     * @return $this
     */
    public function setPointWorkings($point_workings)
    {


        /*if (is_null($point_workings)) {
            throw new \InvalidArgumentException('non-nullable point_workings cannot be null');
        }*/
        $this->container['point_workings'] = $point_workings;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


